<!DOCTYPE html>
<html lang="en-us">
<head>

  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="generator" content="Source Themes Academic 3.1.0">
  <meta name="generator" content="Hugo 0.50" />
  <meta name="author" content="Jeremy Jackson">

  
  
  
  
    
  
  <meta name="description" content="Vagrant can help you create consistency in how you build and deploy software. Here are some basics.">

  
  <link rel="alternate" hreflang="en-us" href="https://ackso.net/post/why-i-use-vagrant-so-much/">

  


  

  

  

  
  
  
  <meta name="theme-color" content="#2962ff">
  

  
  
  
  
    
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha256-eSi1q2PG6J7g7ib17yAaWMcrr5GrtohYChqibrV7PBE=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/academicons/1.8.6/css/academicons.min.css" integrity="sha256-uFVgMKfistnJAfoCUQigIl+JfUaP47GrRKjf6CTPVmw=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.5.0/css/all.css" integrity="sha384-B4dIYHKNBt8Bc12p+WXckhzcICo0wtJAoU8YZTY5qE0Id1GSseTk6S+L3BlXeVIU" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.css" integrity="sha256-ygkqlh3CYSUri3LhQxzdcm0n1EQvH2Y+U5S2idbLtxs=" crossorigin="anonymous">

    
    
    
      
    
    
      
      
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" crossorigin="anonymous">
      
    

    

    

  

  
  
  <link rel="stylesheet" href="//fonts.googleapis.com/css?family=Montserrat:400,700|Roboto:400,400italic,700|Roboto+Mono">
  

  <link rel="stylesheet" href="/styles.css">
  

  
  
  

  
  <link rel="alternate" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  <link rel="feed" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  

  <link rel="manifest" href="/site.webmanifest">
  <link rel="icon" type="image/png" href="/img/icon.png">
  <link rel="apple-touch-icon" type="image/png" href="/img/icon-192.png">

  <link rel="canonical" href="https://ackso.net/post/why-i-use-vagrant-so-much/">

  <meta property="twitter:card" content="summary_large_image">
  
  <meta property="og:site_name" content="Sometimes Jeremy Thinks">
  <meta property="og:url" content="https://ackso.net/post/why-i-use-vagrant-so-much/">
  <meta property="og:title" content="Why I Use Vagrant So Much | Sometimes Jeremy Thinks">
  <meta property="og:description" content="Vagrant can help you create consistency in how you build and deploy software. Here are some basics.">
  
  
    
  <meta property="og:image" content="https://ackso.net/img/icon-192.png">
  <meta property="og:locale" content="en-us">
  
  <meta property="article:published_time" content="2017-12-17T17:03:13-07:00">
  
  <meta property="article:modified_time" content="2017-12-17T17:03:13-07:00">
  

  

  

  <title>Why I Use Vagrant So Much | Sometimes Jeremy Thinks</title>

</head>
<body id="top" data-spy="scroll" data-target="#TableOfContents" data-offset="71" >

<nav class="navbar navbar-light fixed-top navbar-expand-lg py-0" id="navbar-main">
  <div class="container">

    
      <a class="navbar-brand" href="/">Sometimes Jeremy Thinks</a>
      
      <button type="button" class="navbar-toggler" data-toggle="collapse"
              data-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
        <span><i class="fas fa-bars"></i></span>
      </button>
      

    
    <div class="collapse navbar-collapse" id="navbar">

      
      
      <ul class="navbar-nav ml-auto">
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#about">
            
            <span>Home</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#posts">
            
            <span>Posts</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#projects">
            
            <span>Projects</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#contact">
            
            <span>Contact</span>
            
          </a>
        </li>

        
        

      

        

        
      </ul>

    </div>
  </div>
</nav>


<article class="article" itemscope itemtype="http://schema.org/Article">

  












  

  
  
  
<div class="article-container pt-3">
  <h1 itemprop="name">Why I Use Vagrant So Much</h1>

  

  
    

<div class="article-metadata">

  
  
  <span itemscope itemprop="author" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>
  

  <span class="article-date">
    
    <meta content="2017-12-17 17:03:13 -0700 MST" itemprop="datePublished">
    <time datetime="2017-12-17 17:03:13 -0700 MST" itemprop="dateModified">
      2017-12-17
    </time>
  </span>
  <span itemscope itemprop="publisher" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>

  
  <span class="middot-divider"></span>
  <span class="article-reading-time">
    8 min read
  </span>
  

  
  
  <span class="middot-divider"></span>
  <a href="/post/why-i-use-vagrant-so-much/#disqus_thread"></a>
  

  

  
  
<div class="share-box" aria-hidden="true">
  <ul class="share">
    <li>
      <a class="twitter"
         href="https://twitter.com/intent/tweet?text=Why%20I%20Use%20Vagrant%20So%20Much&amp;url=https%3a%2f%2fackso.net%2fpost%2fwhy-i-use-vagrant-so-much%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-twitter"></i>
      </a>
    </li>
    <li>
      <a class="facebook"
         href="https://www.facebook.com/sharer.php?u=https%3a%2f%2fackso.net%2fpost%2fwhy-i-use-vagrant-so-much%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-facebook-f"></i>
      </a>
    </li>
    <li>
      <a class="linkedin"
         href="https://www.linkedin.com/shareArticle?mini=true&amp;url=https%3a%2f%2fackso.net%2fpost%2fwhy-i-use-vagrant-so-much%2f&amp;title=Why%20I%20Use%20Vagrant%20So%20Much"
         target="_blank" rel="noopener">
        <i class="fab fa-linkedin-in"></i>
      </a>
    </li>
    <li>
      <a class="weibo"
         href="http://service.weibo.com/share/share.php?url=https%3a%2f%2fackso.net%2fpost%2fwhy-i-use-vagrant-so-much%2f&amp;title=Why%20I%20Use%20Vagrant%20So%20Much"
         target="_blank" rel="noopener">
        <i class="fab fa-weibo"></i>
      </a>
    </li>
    <li>
      <a class="email"
         href="mailto:?subject=Why%20I%20Use%20Vagrant%20So%20Much&amp;body=https%3a%2f%2fackso.net%2fpost%2fwhy-i-use-vagrant-so-much%2f">
        <i class="fas fa-envelope"></i>
      </a>
    </li>
  </ul>
</div>


  

</div>

    















  
</div>



  <div class="article-container">

    <div class="article-style" itemprop="articleBody">
      

<p>I use <a href="https://vagrantup.com" target="_blank">Vagrant</a> for a bunch of different tasks.
If I&rsquo;m forced to use a Windows-based workstation I like to use Vagrant so that I have a standard
Linux virtual machine available to me at all times so that I can do basic types of tasks
that I might need <code>bash</code>, <code>python</code>, <code>ruby</code>, or <code>gnu-utils</code> for.
I also use it for what it&rsquo;s mostly intended for: <strong>having a development environment that mimics
my targetted deployment environment in as many ways as possible.</strong></p>

<p>Suppose that I&rsquo;m working on a MEAN stack website.
I probably don&rsquo;t want to actually just build it on my machine, especially if I&rsquo;m working with
someone else.
Yes, my personal machines all use Debian Stable, which should be just fine for development that
targets an Ubuntu VM in the cloud, or on a VPS, but my personal machines also have a bunch of
software installed that has nothing to do with the operation of a website.
I&rsquo;m talking about things like window and desktop managers, web browsers, my time tracking
application, sqlite, and lots of other software that&rsquo;s out there.</p>

<p>Let&rsquo;s complicate this further and suppose that I&rsquo;m collaborating on this with a teammate who&rsquo;s
on a Mac.
Just for the heck of it, let&rsquo;s say that we have third teammate helping us out who&rsquo;s on Windows.
They have all of their own stuff running on their machines that works in different and unique
ways that fail to be close in any way to the deployment target.
So in this situation, we need a way to have a common target that we can develop and test towards.
<strong>This is where Vagrant comes to the rescue.</strong></p>

<h2>Table of Contents</h2>
<nav id="TableOfContents">
<ul>
<li><a href="#about-vagrant">About Vagrant</a></li>
<li><a href="#ways-that-vagrant-helps-our-work">Ways that Vagrant helps our work</a></li>
<li><a href="#the-vagrantfile">The Vagrantfile</a></li>
<li><a href="#launching-vagrant">Launching Vagrant</a></li>
<li><a href="#dealing-with-misconfiguration">Dealing with misconfiguration</a></li>
<li><a href="#wrapping-up">Wrapping up</a></li>
<li><a href="#resources">Resources</a></li>
</ul>
</nav>


<h1 id="about-vagrant">About Vagrant</h1>

<p>Vagrant (<a href="https://github.com/hashicorp/vagrant" target="_blank">github</a>) is a tool built mostly in Ruby for
driving Virtual Machines across different platforms in a standardized way.
It integrates well with various configuration management tools like Chef, and is even
capable of driving your VM&rsquo;s in most, if not all, major cloud providers.</p>

<p>I (and my colleagues) predominantly use it to drive VirtualBox on our workstations,
though we&rsquo;re hoping that as our IT org moves more towards infrastructure-as-code we&rsquo;ll
be able to get them to give us standardized images as well as the ability to deploy these
directly to our cloud provider.</p>

<h1 id="ways-that-vagrant-helps-our-work">Ways that Vagrant helps our work</h1>

<p>So far I&rsquo;ve only explained how Vagrant helps my team collaborate on development towards a common
deployment target, regardless of what kind of operating systems we&rsquo;re actually running on our
workstations.
For actually doing the work, Vagrant also helps in bunch of other ways.</p>

<p>We automatically suppose that our ultimate deployment target is just going to be a barebones
Linux VM, probably either CentOS or Ubuntu.
However, we have a bunch of software that we need to install in order to be able to get a running
website, analytics service, or database.
Vagrant helps here because we can create provisioning scripts in something like bash (or a
configuration management system if we were more advanced) and lets us provision, modify scripts,
and reprovision virtual machines on our workstations in very quick iterations.
That way, if something is messed up in the way we configured our server or software we can
quickly detect that, fix it in the script, and then reprovision the VM to test and check it out.
We can even include scripts to do things like configuring our <code>cron</code> jobs, setting up <code>systemd</code>
so that the process running our website can start on boot and recover from failures,
configure our webserver (like <code>nginx</code> or <code>apache</code>), and any number of other things that we
would like to happen during server provisioning.
The best part is that we haven&rsquo;t wasted a dime on our actual deployment server yet!</p>

<h1 id="the-vagrantfile">The Vagrantfile</h1>

<p>You configure your VM&rsquo;s using a <code>Vagrantfile</code>, which specifies the VM image you want to use,
the size of the VM (think CPU cores and memory), what kind of a networking situation needs to
happen to make it similar to the deployment target (like available ports, etc), and shared
folders (so that you can still just modify all of your code using your local text editor, and
not whatever is available once you login to the VM).
<code>Vagrantfile</code>s have a lot of different configuration options, but these are the ones that are
probably most important for a normal user, along with telling it what scripts you want it to
run as part of the provisioning process.
Since your <code>Vagrantfile</code> is just ruby code, you get the benefit of being able to include it in
your project&rsquo;s repository, so that it can be easily shared with all the members of your team.</p>

<p>So let&rsquo;s say that you want to use Vagrant for a project.
Doing a basic setup is extremely easy.
You just run <code>vagrant init</code> and it will create a barebones <code>Vagrantfile</code> for you to modify
as needed.</p>

<p>So, what do you put in your <code>Vagrantfile</code>?
Let&rsquo;s make a list about what we know about our website project:</p>

<ul>
<li>We need to have port 80 available.</li>
<li>We plan on using <code>nginx</code> and <code>mysql</code>.</li>
<li>We need NodeJS, version 8.x installed.</li>
<li>Deployment target is Ubuntu 16.04.</li>
</ul>

<p>When you open your Vagrantfile, it will have a bunch of boilerplate with some sensible defaults
and explanations about common configuration settings that you can have.
I&rsquo;m going to exclude all of that here and just put in the Vagrant configs that we actually need
to accomplish what&rsquo;s in our list.</p>

<pre><code class="language-ruby">Vagrant.configure(&quot;2&quot;) do |config|

  # The bento project provides high quality VM images for a number of Linux OS's.
  config.vm.box = &quot;bento/ubuntu-16.04&quot;

  # We need port 80 on our VM, but let's forward it port 8080 on the laptop.
  config.vm.network &quot;forwarded_port&quot;, guest: 80, host: 8080

  # Here's our VirtualBox configurations
  config.vm.provider &quot;virtualbox&quot; do |vb|
    # Display the VirtualBox GUI when booting the machine
    vb.gui = false
  
    # Customize the amount of memory on the VM:
    vb.memory = &quot;1024&quot;
    vb.cores = &quot;2&quot;
  end

  # We could modify this to point at a provision script, but we'll just do it inline.
  # Keep in mind that everything in this block is run as root at /home/vagrant.
  config.vm.provision &quot;shell&quot;, inline: &lt;&lt;-SHELL
    # Copied from https://github.com/nodesource/distributions
    curl -sL https://deb.nodesource.com/setup_8.x | sudo -E bash -

    apt-get update
    apt-get install -y nginx mysql git nodejs
  SHELL

end
</code></pre>

<h1 id="launching-vagrant">Launching Vagrant</h1>

<p>Once the Vagrantfile is written we can launch the VM by running <code>vagrant up</code> and we&rsquo;ll soon
have a running VM.
Keep in mind that the first time you run <code>vagrant up</code> for any particular Virtual Machine Image
(<code>bento/ubuntu-16.04</code> in this case), Vagrant will first download the Virtual Machine Image
(called <code>boxes</code> in Vagrant parlance) into a default VM library, then create a copy of it to be
configured according to what you&rsquo;ve specified.
Because of this, you definitely need a fast internet connection, and ideally should have an SSD
installed to your workstation.
Once you have that box downloaded once, you won&rsquo;t have to download it again, though Vagrant
may let you know when a new version of the box is available for download.</p>

<p>Vagrant will also print out a bunch of messages describing what it&rsquo;s doing at any given moment,
as well as everything that gets printed to <code>stdout</code> and <code>stderr</code> as a result of the commands
run in your <code>config.vm.provision</code> block.
When the provisioning process is complete, Vagrant will return you to your command prompt with
either a success message or a message that there was some kind of failure.
If it was a success, and even in some failure cases, you should now be able to log in to your
running VM by using <code>vagrant ssh</code>.
Then, once you&rsquo;re in you can check that everything is as you intended the configuration to be.</p>

<h1 id="dealing-with-misconfiguration">Dealing with misconfiguration</h1>

<p>If you do find a problem with your configuration you can start editing your <code>Vagrantfile</code> and
provisioning scripts to correct your mistakes.
Once you&rsquo;re done making your changes you reprovision the VM at a level appropriate for the change
you&rsquo;re making.</p>

<pre><code class="language-bash"># Say you're just changing a minor configuration detail, you can just run:
vagrant reload --provision

# If you made some big changes and want to start with a fresh box:
vagrant destroy
vagrant up
</code></pre>

<p>Keep in mind that just doing <code>vagrant reload --provision</code> will also take less time than destroying
and starting totally fresh, so just be aware of what you&rsquo;re doing and not wasting more time than
you need to in getting your configurations correct.</p>

<h1 id="wrapping-up">Wrapping up</h1>

<p>So we&rsquo;ve covered some good uses and reasons for using Vagrant, we did a quick demo showing off
how to configure a Vagrant box for use in a project, and how to deal with configuration problems.
Now it&rsquo;s up to you to find novel uses of this great piece of software and start building
good, reproducible software with it!</p>

<h1 id="resources">Resources</h1>

<ul>
<li><a href="https://vagrantup.com" target="_blank">Vagrant</a></li>
<li><a href="https://github.com/hashicorp/vagrant" target="_blank">Vagrant on Github</a></li>
<li><a href="https://virtualbox.org" target="_blank">VirtualBox</a></li>
<li><a href="https://hashicorp.com" target="_blank">HashiCorp, the makers of Vagrant</a></li>
<li><a href="https://github.com/chef/bento" target="_blank">The Bento Project, by Chef.io</a></li>
<li><a href="https://chef.io" target="_blank">Chef</a></li>
<li><a href="https://app.hashicorp.com/boxes/search" target="_blank">Discover other Vagrant Boxes here</a></li>
</ul>

    </div>

    


<div class="article-tags">
  
  <a class="badge badge-light" href="/tags/vagrant/">vagrant</a>
  
  <a class="badge badge-light" href="/tags/virtualization/">virtualization</a>
  
  <a class="badge badge-light" href="/tags/simulation/">simulation</a>
  
  <a class="badge badge-light" href="/tags/reproducibility/">reproducibility</a>
  
</div>



    






<div class="media author-card" itemscope itemtype="http://schema.org/Person">
  
  <img class="portrait mr-3" src="/img/portrait.jpg" itemprop="image" alt="Avatar">
  
  <div class="media-body">
    <h5 class="card-title" itemprop="name"><a href="/">Jeremy Jackson</a></h5>
    <h6 class="card-subtitle">Software Engineering and Data Science</h6>
    
    <ul class="network-icon" aria-hidden="true">
      
      
      
      
      
      
      
      
      <li>
        <a itemprop="sameAs" href="mailto:jeremy_j@ackso.net" >
          <i class="fa fa-envelope"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//twitter.com/jeremy_j_ackso" >
          <i class="fab fa-twitter"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//github.com/jeremy-j-ackso" >
          <i class="fab fa-github"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//gitlab.com/jeremy.jackson" >
          <i class="fab fa-gitlab"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//linkedin.com/in/jeremy-jackson-249878153" >
          <i class="fab fa-linkedin"></i>
        </a>
      </li>
      
    </ul>
  </div>
</div>




    
    

    

    
<section id="comments">
  <div id="disqus_thread"></div>
<script type="application/javascript">
    var disqus_config = function () {
    
    
    
    };
    (function() {
        if (["localhost", "127.0.0.1"].indexOf(window.location.hostname) != -1) {
            document.getElementById('disqus_thread').innerHTML = 'Disqus comments not available by default when the website is previewed locally.';
            return;
        }
        var d = document, s = d.createElement('script'); s.async = true;
        s.src = '//' + "ackso-net.disqus.com" + '.disqus.com/embed.js';
        s.setAttribute('data-timestamp', +new Date());
        (d.head || d.body).appendChild(s);
    })();
</script>
<noscript>Please enable JavaScript to view the <a href="https://disqus.com/?ref_noscript">comments powered by Disqus.</a></noscript>
<a href="https://disqus.com" class="dsq-brlink">comments powered by <span class="logo-disqus">Disqus</span></a>
</section>



  </div>
</article>

<div class="container">
  <footer class="site-footer">
  

  <p class="powered-by">
    &copy; 2017 Jeremy T Jackson &middot; 

    Powered by the
    <a href="https://sourcethemes.com/academic/" target="_blank" rel="noopener">Academic theme</a> for
    <a href="https://gohugo.io" target="_blank" rel="noopener">Hugo</a>.

    
    <span class="float-right" aria-hidden="true">
      <a href="#" id="back_to_top">
        <span class="button_icon">
          <i class="fas fa-chevron-up fa-2x"></i>
        </span>
      </a>
    </span>
    
  </p>
</footer>

</div>


<div id="modal" class="modal fade" role="dialog">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Cite</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <pre><code class="tex hljs"></code></pre>
      </div>
      <div class="modal-footer">
        <a class="btn btn-outline-primary my-1 js-copy-cite" href="#" target="_blank">
          <i class="fas fa-copy"></i> Copy
        </a>
        <a class="btn btn-outline-primary my-1 js-download-cite" href="#" target="_blank">
          <i class="fas fa-download"></i> Download
        </a>
        <div id="modal-error"></div>
      </div>
    </div>
  </div>
</div>

    

    
    
    
    
    <script src="/js/mathjax-config.500a6cbb2c0f345fcecc21b3116d6637aa78f1f11db8081ea581abe05390c2e8f3bbffe61be3cf0217baf785c40efceabe51050a4f007e69af94efd3643260e8.js" integrity="sha512-UApsuywPNF/OzCGzEW1mN6p48fEduAgepYGr4FOQwujzu//mG&#43;PPAhe694XEDvzqvlEFCk8AfmmvlO/TZDJg6A=="></script>
    

    
    
    
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js" integrity="sha512-+NqPlbbtM1QqiK8ZAo4Yrj2c4lNQoGv8P79DPtKzj++l5jnN39rHA/xsqn8zE9l0uSoxaCdrOgFs6yjyfbBxSg==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.imagesloaded/4.1.3/imagesloaded.pkgd.min.js" integrity="sha512-umsR78NN0D23AzgoZ11K7raBD+R6hqKojyBZs1w8WvYlsI+QuKRGBx3LFCwhatzBunCjDuJpDHwxD13sLMbpRA==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha256-VsEqElsCHSGmnmHXGQzvoWjWwoznFSZc6hs7ARLRacQ=" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.isotope/3.0.4/isotope.pkgd.min.js" integrity="sha512-VDBOIlDbuC4VWxGJNmuFRQ0Li0SKkDpmGyuhAG5LTDLd/dJ/S0WMVxriR2Y+CyPL5gzjpN4f/6iqWVBJlht0tQ==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.js" integrity="sha256-X5PoE3KU5l+JcX+w09p/wHl9AzK333C4hJ2I9S5mD4M=" crossorigin="anonymous"></script>

      
        
        <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js" integrity="sha256-/BfiIkHlHoVihZdc6TFuj7MmJ0TWcWsMXkeDFwhi0zw=" crossorigin="anonymous"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/python.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/r.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/bash.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/css.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/diff.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/javascript.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/json.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/markdown.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/nginx.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/processing.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/scala.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/sql.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/tex.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/vim.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/yaml.min.js"></script>
        
      

      
      
      <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.4/MathJax.js?config=TeX-AMS_CHTML-full" integrity="sha256-GhM+5JHb6QUzOQPXSJLEWP7R73CbkisjzK5Eyij4U9w=" crossorigin="anonymous" async></script>
      
    

    <script src="/js/hugo-academic.js"></script>
    

    
    

    
    
    
    <script id="dsq-count-scr" src="//ackso-net.disqus.com.disqus.com/count.js" async></script>
    

    
    
    <script>hljs.initHighlightingOnLoad();</script>
    

    
    
    <script>
      const search_index_filename = "/index.json";
      const i18n = {
        'placeholder': "Search...",
        'results': "Search Results",
        'no_results': "No results found"
      };
      const content_type = {
        'post': "Posts",
        'project': "Projects",
        'publication' : "Publications",
        'talk' : "Talks"
        };
    </script>
    

    
    

    

    
    

    
    

  </body>
</html>

